/*******************************************************
ウィルコムガジェット共通ライブラリ by WILLCOM NEWS LABO
http://labo.willcomnews.com
これから少しずつ足していく予定です。
利用・再配布等自由ですので、気軽にご利用ください

改変して再配布する場合には連絡をいただけると嬉しいです。
（不要なものの削除レベルならば気にしなくて良いです）
////////////////////////////////////////////////////////
更新履歴
 2008/12/16 新規作成
 2008/12/27 最大化・最小化処理を修正
 2009/01/07 二重起動防止のチェック方法を修正
 2009/01/08 指定時刻ウェイクアップメソッドを追加
 2009/01/31 メッセージボックスの処理を追加（仮）
 2009/06/01 メッセージボックスの処理他を修正
 2009/07/03 プレーンデータの取得処理を追加
*******************************************************/

//最大化状態
var fullMode = false;
var smallFunction;
var largeFunciton;
var onClickFunciton;
var lastEvent;
var messageBox;
var iconImage;
var checkImage;
var checkImageList;
var vflg = true;
var msgAfterFunciton;
var baseImage;
var imageLength;
var imageCompCnt;
var checkImageSrcList;
var okButton;
var cancelButton;
var messageVisible = false;


//データ保存
function saveData(key,data)
{
	//書き込み
	widget.setPreferenceForKey(data,key);
	widget.savePreferences();
}

//データ読込
function loadData(key)
{
	//読み込み
	var value = widget.preferenceForKey(key);
	if (typeof(value)=="undefined") value = "";
	return value;
}

function setIcon(iconUrl,iconwidth,iconheight)
{
	iconImage=null;

	iconImage = document.createElement("img");
	iconImage.id = "icon";
	iconImage.setAttribute("id","icon");
	iconImage.style.width = iconwidth;
	iconImage.style.height = iconheight;
	iconImage.src = iconUrl;

	document.body.appendChild(iconImage);
	iconImage.style.position = 'absolute';
	iconImage.style.left = 0;
	iconImage.style.top = 0;
}
function updateIcon(iconUrl)
{
	iconImage.src = iconUrl;
}



//アイコン画面時処理
function toSmaill()
{
	fullMode=false;
	if (typeof(iconImage) != "undefined")
	{
		document.body.appendChild(iconImage);
		iconImage.style.position = 'absolute';
		iconImage.style.left = 0;
		iconImage.style.top = 0;
	}

	smallFunction();
}

//最大化時処理
function toLarge()
{
	fullMode=true;
	if (typeof(iconImage) != "undefined")
	{
		document.body.removeChild(iconImage);
	}
	
	largeFunciton();
}

//最大化イベント
function fullModeEvent(event)
{
	if(!fullMode)
	{
		if (event.keyCode==13){
			widget.system.setProperty('WILLCOM-WIDGET-REQUEST-CHANGE-STATE','MAXIMIZE');
		}
		return false;
	}

	if (messageBox != null)
	{
		messageBox.style.width = 0;
		messageBox.style.height = 0;
		document.body.removeChild(messageBox);
		clearInterval(timerID);
		messageBox =null;
		messageVisible=false;

		document.onkeydown=lastEvent;
	}

	onClickFunciton(event);
}


//初期処理
//toSmallFunc:画面最小化時に実行する処理
//toLargeFunc:画面最大化時に実行する処理
function initialize(toSmallFunc,toLargeFunc,clickFunciton)
{
	fullMode = false;
	smallFunction = toSmallFunc;
	largeFunciton = toLargeFunc;
	onClickFunciton = clickFunciton;

	widget.onrestore  = toSmaill;
	widget.onmaximize = toLarge;
	document.onkeydown = fullModeEvent;
}

//二重起動
function checkExecutable(closeFunc)
{
	var mutexId="Ap_Mutex";
	var value = widget.identifier;

	var nowvalue = widget.preferenceForKey(mutexId);
	if (typeof(nowvalue) == "undefined") nowvalue="";

	if (nowvalue != value && nowvalue != "")
	{
		document.body.innerHTML = '<b>二重起動禁止です。メニューからガジェット閉じるを選んでください。</b>';
		return false;
	}

	//書き込み
	widget.setPreferenceForKey(value,mutexId);
	widget.savePreferences();

	//終了時の処理を設定
	widget.onremove = function() {
		closeFunc();
		widget.setPreferenceForKey(null,mutexId);
		widget.savePreferences();
	}
	return true;
}

//位置情報取得
function getLocation(evFunction)
{
	var loc;
	loc = widget.location;
	if (!loc.measurable) return false;
	loc.onupdate = function () {
		getLoc = loc.getInfo();
		evFunction(getLoc.latitude,getLoc.longitude);
	}
	loc.update();
	return true;
}

//ネットワーク接続（GET)
function getWebData(url,evFunction,pget) 
{
	var request = new XMLHttpRequest();
	request.onreadystatechange = function() {
		switch (request.readyState) {
			case 0:
				break;
			case 1:
				break;
			case 2:
				break;
			case 3:
				break;
			case 4:
				if (request.status == 200) {
					var xmlDoc;
					if (pget == true)
						xmlDoc = request.responseText;
					else
						xmlDoc = request.responseXML.documentElement;

					evFunction(xmlDoc);
				}
				else
				{
					evFunction("ERROR");
				}
				break;
		}

	}
	request.open("GET", url);
	request.send();
}

//ネットワーク接続（POST）
function postWebData(url,param,evFunction,pget) 
{
	var request = new XMLHttpRequest();
	request.onreadystatechange = function() {
		switch (request.readyState) {
			case 0:
				break;
			case 1:
				break;
			case 2:
				break;
			case 3:
				break;
			case 4:
				if (request.status == 200) {
					var xmlDoc;
					if (pget == true)
						xmlDoc = request.responseText;
					else
						xmlDoc = request.responseXML.documentElement;

					evFunction(xmlDoc);
				}
				else {
					evFunction("ERROR");
				}
				break;
		}
	}
	request.open("POST", url);
	request.send(param);
}
//ブラウザ起動
function browserOpen(url)
{
	widget.openURL(url);
}

//日付指定起動時間指定
function setWakeupOnTime(date)
{
	var timeValue = date.getFullYear() + ':'
				+zeroPadding(date.getMonth()+1)+':'
				+zeroPadding(date.getDate())+':'
				+zeroPadding(date.getHours())+':'
				+zeroPadding(date.getMinutes());

	widget.system.setProperty('WILLCOM-WIDGET-WAKEUP-TIME',timeValue);
	return date;
}

//～分後指定起動時間指定
function setWakeupExpired(addminutes)
{
	var	time = new Date();
	var baseSec = time.getTime();
	var addSec = addminutes * 60000;
	var targetSec = baseSec + addSec;
	time.setTime(targetSec);

	return setWakeupOnTime(time);
}

//メッセージ表示処理
function showMessageDlg(message,boxwidth,boxheight,boxtop,boxleft,button1,button2,afterFunction)
{
	if (fullMode)
	{

		if (boxwidth == null)
			boxwidth = window.innerWidth-10;

		if (boxheight == null)
			boxheight = window.innerHeight-10;

		if (boxleft == null)
			boxleft = (window.innerWidth-boxwidth)/2;

		if (boxtop == null)
			boxtop = (window.innerHeight-boxheight)/2;

		if (button1 == null)
			button1 = 13;

		lastEvent = document.onkeydown;
		document.onkeydown = messageBoxEvents;
		msgAfterFunciton=afterFunction;

		okButton = button1;
		cancelButton = button2;

		//メッセージボックス作成
		makeMessageBox(boxwidth,boxheight,message,"#000000","#eeffee");

		messageBox.style.verticalAllign='baseline';

		document.body.appendChild(messageBox);
		messageBox.style.position = 'absolute';
		messageBox.style.left = boxleft;
		messageBox.style.top = boxtop;

		messageVisible=true;
	}
}

//メッセージ表示処理（画像読込待ち）
function showImageWaitDialog(image,boxwidth,boxheight,boxtop,boxleft,button1,button2)
{
	if (boxwidth == null)
		boxwidth = window.innerWidth-10;

	if (boxheight == null)
		boxheight = window.innerHeight-10;

	if (boxleft == null)
		boxleft = (window.innerWidth-boxwidth)/2;

	if (boxtop == null)
		boxtop = (window.innerHeight-boxheight)/2;

	if (button1 == null)
		button1 = 13;

	checkImage=image;
	if (!checkImage.complete)
	{
		lastEvent = document.onkeydown;

		document.onkeydown = messageBoxEvents2;

		//メッセージボックス作成
		makeMessageBox(boxwidth,boxheight,"<br>読込中","#000000","#eeeeff");

		messageBox.style.verticalAllign='baseline';

		document.body.appendChild(messageBox);
		messageBox.style.position = 'absolute';
		messageBox.style.left = boxleft;
		messageBox.style.top = boxtop;
		vflg= true;

		messageVisible=true;

		timerID = setInterval('checkTimer()' , 500) ;
	}
}

//メッセージ表示処理（画像読込待ち2画像リストの表示待）
function showImageListWaitDialog(pageImageSrcList,imageList,boxwidth,boxheight,boxtop,boxleft,button1,button2)
{
	if (boxwidth == null)
		boxwidth = window.innerWidth-10;

	if (boxheight == null)
		boxheight = window.innerHeight-10;

	if (boxleft == null)
		boxleft = (window.innerWidth-boxwidth)/2;

	if (boxtop == null)
		boxtop = (window.innerHeight-boxheight)/2;

	if (button1 == null)
		button1 = 13;

	checkImageList=imageList;
	checkImageSrcList = pageImageSrcList;
	baseImage = new Image();
	baseImage.src=pageImageSrcList[0];

	imageCompCnt=0;
	imageLength=pageImageSrcList.length;

	lastEvent = document.onkeydown;

	document.onkeydown = messageBoxEvents2;

	//メッセージボックス作成
	makeMessageBox(boxwidth,boxheight,"<br>読込中[0/"+imageLength+"]","#000000","#eeeeff");

	messageBox.style.verticalAllign='baseline';

	document.body.appendChild(messageBox);
	messageBox.style.position = 'absolute';
	messageBox.style.left = boxleft;
	messageBox.style.top = boxtop;
	vflg= true;
	messageVisible=true;


	timerID = setInterval('checkTimer2()' , 500) ;

}

//内部使用関数（メッセージボックスイベント）
function messageBoxEvents2(event)
{
	if (event.keyCode==34){
		messageBox.style.width = 0;
		messageBox.style.height = 0;
		document.body.removeChild(messageBox);
		clearInterval(timerID);
		messageBox =null;
		messageVisible=false;

		document.onkeydown=lastEvent;

		showMessageDlg('<br>読込待停止',110,50,60,38,13);
	}
}

//内部使用関数（メッセージボックス作成）
function makeMessageBox(boxwidth,boxheight,message,forecolor,backcolor)
{
	messageBox = document.createElement("span");
	messageBox.id = "messageBox";
	messageBox.setAttribute("id","messageBox");
	messageBox.style.backgroundColor  = backcolor;
	messageBox.style.color = forecolor;
	messageBox.style.width = boxwidth;
	messageBox.style.height = boxheight;
	messageBox.style.textAlign = 'center'
	messageBox.innerHTML = message;
}

//内部使用関数（画像待メッセージボックス処理用）
function checkTimer()
{
	if (checkImage.complete)
	{
		messageBox.style.width = 0;
		messageBox.style.height = 0;
		document.body.removeChild(messageBox);
		clearInterval(timerID);
		messageBox =null;
		messageVisible=false;
		document.onkeydown=lastEvent;
	}
	else if (checkImage.finish)
	{
		messageBox.innerHTML = '読込エラー？';
	}

	else{
		if (vflg)
		{
			messageBox.innerHTML = "<br>読込中";
			vflg=false;
		}
		else
		{
			messageBox.innerHTML = "";
			vflg=true;
		}
	}

}

//内部使用関数（画像リスト待メッセージボックス処理用）
function checkTimer2()
{
	var compFlg = true;

	if (baseImage.complete)
	{
		checkImageList[imageCompCnt] = baseImage;
		imageCompCnt++;

		if (imageCompCnt < imageLength)	
		{
			baseImage = new Image();
			baseImage.src=checkImageSrcList[imageCompCnt];
		}

	}

	if (imageCompCnt >= imageLength)	
	{
		messageBox.style.width = 0;
		messageBox.style.height = 0;
		document.body.removeChild(messageBox);
		clearInterval(timerID);
		messageBox =null;
		document.onkeydown=lastEvent;
		messageVisible=false;
	}else{
		if (vflg)
		{
			messageBox.innerHTML = "<br>読込中["+imageCompCnt+"/"+imageLength+"]";
			vflg=false;
		}
		else
		{
			messageBox.innerHTML = "";
			vflg=true;
		}
	}

}

//0パディング処理（内部使用だが、外からも使用可能
function zeroPadding(num)
{
	if (num<10)
		return '0'+num;
	else
		return ''+ num;
}


//内部使用関数（メッセージボックスイベント）
function messageBoxEvents(event)
{
	if (event.keyCode==okButton || event.keyCode == cancelButton){
		messageBox.style.width = 0;
		messageBox.style.height = 0;
		document.onkeydown=lastEvent;
		document.body.removeChild(messageBox);
		messageBox =null;
		messageVisible=false;

		if (typeof(msgAfterFunciton) != "undefined" && event.keyCode==okButton)
		{
			msgAfterFunciton();
		}
	}
}
